/* SI 413 Fall 2011
 * Implementations of Frame class methods
 */

#include <cstdlib>
#include "frame.hpp"

int Frame::nextFree = 0;

int Frame::lookup(string name) {
  if (bindings.count(name) > 0)
    return bindings[name];
  else if (parent != NULL)
    return parent->lookup(name);
  else {
    cerr << "No binding for " << name << endl;
    exit(1);
  }
}

void Frame::add(string name) {
  if (bindings.count(name) == 0) {
    bindings[name] = nextFree;
    ++nextFree;
  }
  else
    cerr << "Variable " << name << " is already bound!" << endl;
}
