/* SI 413 Fall 2011
 * C++ header file for the Frame class
 * Supports lexical scope
 */

#ifndef FRAME_HPP
#define FRAME_HPP

#include <iostream>
#include <map>
#include <string>
using namespace std;

/* This class represents a lexical frame. */
class Frame {
  private:
    // The next free memory location
    static int nextFree;

    map<string,int> bindings;
    Frame* parent;

  public:
    // Constructor takes a pointer to the parent frame.
    // Symbol table will initially be empty.
    Frame (Frame* p = NULL) :parent(p) { }

    // Returns the Value bound to the given name.
    int lookup(string name);

    // Creates a new binding location
    void add(string name);
};

#endif // FRAME_HPP
